ROM    ;	      ROM/ASM  - Version 1.0
 ;       	 NEWDOS80/V2  (III) 
 ;	          3rd March 1985
 ;        For NORTHERN BYTES & the PUBLIC DOMAIN
 ;                  by Tony Domigan
 ;  PO Box 150, Thomastown, Victoria, 3074, Australia
 ;MCI-ID:2545121. SOURCE-ID:BCT039. TAB-ID:DOMIPOBOWINN
 ;------------------------------------------------------
 ;
 	ORG	5200H
 START	PUSH	HL		;Save buffer pointer
 	CALL	01C9H		;CLS
 	POP	HL		;Restore cmd pointer
 	LD	A,(HL)		;Command parsed
 	CP	0DH		;CR=NO
 	JR	Z,WHAT		;Skip if CR
 	AND	0DFH		;Mask out L/C
 	CP	'S'		;Saverom?
 	JP	Z,SVROM		;Yes, doit
 	CP	'R'		;Restore ROM?
 	JR	Z,GETROM	;Yes, doit
 WHAT	LD	HL,PROMPT	;Menu
 	CALL	4467H		;Disp menu
 ILOOP	CALL	49H		;Wait for key
 	AND	0DFH		;Mask out L/C
 	CP	'R'		;Restore ROM
 	JR	Z,GETROM	;Yes, doit
 	CP	'S'		;Save ROM?
 	JP	Z,SVROM		;Yes, doit
 	JR	ILOOP		;Try again
 ;
 GETROM	LD	HL,BOOMSG	;Romboot msg
 	CALL	4467H		;Display msg
 	CALL	DELAY		;Wait a while
 	LD	A,31H		;Mv upper bank & open ROM
 	LD	(SWITCH+1),A	;Post code in swap
 	LD	HL,8000H	;Start of moved RAM
 	LD	DE,0000H	;Dest of saved ROM
 	LD	BC,37FFH	;ROM length
 	CALL	SWAP		;Swap banks & mv data
 	RST	00H		;RE-BOOT
 ;
 SVROM	LD	HL,0000H
 	LD	DE,8000H	;Start bank 3 (high)
 	LD	BC,37FFH	;Bytes to Transfer
 	CALL	SWAP		;Transfer ROM to Bank3
 	LD	HL,MSG1		;Pt to info message
 	CALL	4467H		;Print message
 	CALL	60H		;delay
 	CALL	60H		;delay
 	CALL	60H		;delay
 	JP	402DH
 ;
 SWAP	DI			;must do this
 SWITCH	LD	A,30H		;upper bank switched high
 	OUT	(84H),A		;switch bank to 8000-FFFF
 	LDIR			;Move ROM to 8000+
 	XOR	A		;A=0
 	OUT	(84H),A		;Reinstate banks
 	EI
 	RET
 DELAY	LD	BC,0000H	
 	LD	DE,0003H	;3 passes
 	CALL	4C95H		;Multiple delay
 	RET
 PROMPT	DEFB	0AH
 	DEFB	10H
 	DEFM	' Upper Bank Memory Transfer Utility  - by Tony Domigan '
 	DEFB	11H
 	DEFW	0A0AH
 	DEFB	10H
 	DEFM	'Save ROM to upper 64K "S" '
 	DEFB	11H
 	DEFW	0A0AH
 	DEFB	10H
 	DEFM	'Return the saved ROM  "R" '
 	DEFB	11H
 	DEFW	0A0AH
 	DEFW	0711H
 	DEFB	0DH
 BOOMSG	DEFB	0AH
 	DEFB	10H
 	DEFM	'Restoring Saved ROM to allow the booting of NEWDOS80 '
 	DEFW	0711H
 	DEFB	0DH
 MSG1	DEFM	'ROM SAVED - USE R option to REBOOT '
 	DEFB	0DH
 	END	START
